## liblol 0.1.6

=== glibc/gmon/Makefile ===
# Copyright (C) 1995-2024 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for gmon portion of the library.
#
subdir	:= gmon

include ../Makeconfig

headers := \
  sys/gmon.h \
  sys/gmon_out.h \
  sys/profil.h \
  # headers
routines := \
  gmon \
  mcount \
  prof-freq \
  profil \
  sprofil \
  # routines

tests = \
  tst-gmon \
  tst-mcleanup \
  tst-mcount-overflow \
  tst-sprofil \
  # tests
ifeq ($(build-profile),yes)
tests += tst-profile-static
tests-static += tst-profile-static

LDFLAGS-tst-profile-static = -profile
endif

tests += tst-gmon-static
tests-static += tst-gmon-static

ifeq (yesyes,$(have-fpie)$(build-shared))
tests += tst-gmon-pie
tests-pie += tst-gmon-pie
ifeq (yes,$(enable-static-pie))
tests += tst-gmon-static-pie
tests-static += tst-gmon-static-pie
endif
endif

# The mcount code won't work without a frame pointer.
CFLAGS-mcount.c := -fno-omit-frame-pointer

CFLAGS-tst-gmon.c := -fno-omit-frame-pointer -pg
tst-gmon-no-pie = yes
CRT-tst-gmon := $(csu-objpfx)g$(start-installed-name)
tst-gmon-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-gprof.out
endif

CFLAGS-tst-mcount-overflow.c := -fno-omit-frame-pointer -pg
tst-mcount-overflow-no-pie = yes
CRT-tst-mcount-overflow := $(csu-objpfx)g$(start-installed-name)
# Intentionally use invalid config where maxarcs<minarcs to check warning is printed
tst-mcount-overflow-ENV := GMON_OUT_PREFIX=$(objpfx)tst-mcount-overflow.data \
                           GLIBC_TUNABLES=glibc.gmon.minarcs=51:glibc.gmon.maxarcs=50
# Send stderr into output file because we make sure expected messages are printed
tst-mcount-overflow-ARGS := 2>&1 1>/dev/null | cat
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-mcount-overflow-check.out
endif

CFLAGS-tst-mcleanup.c := -fno-omit-frame-pointer -pg
tst-mcleanup-no-pie = yes
CRT-tst-mcleanup := $(csu-objpfx)g$(start-installed-name)
tst-mcleanup-ENV := GMON_OUT_PREFIX=$(objpfx)tst-mcleanup.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-mcleanup.out
endif

CFLAGS-tst-gmon-static.c := $(PIE-ccflag) -fno-omit-frame-pointer -pg
CRT-tst-gmon-static := $(csu-objpfx)g$(static-start-installed-name)
tst-gmon-static-no-pie = yes
tst-gmon-static-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon-static.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-static-gprof.out
endif

CFLAGS-tst-gmon-pie.c := $(PIE-ccflag) -fno-omit-frame-pointer -pg
CRT-tst-gmon-pie := $(csu-objpfx)g$(start-installed-name)
tst-gmon-pie-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon-pie.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-pie-gprof.out
endif

ifeq (yes,$(enable-static-pie))
CFLAGS-tst-gmon-static-pie.c := $(PIE-ccflag) -fno-omit-frame-pointer -pg
CRT-tst-gmon-static-pie := $(csu-objpfx)gr$(static-start-installed-name)
tst-gmon-static-pie-ENV := GMON_OUT_PREFIX=$(objpfx)tst-gmon-static-pie.data
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-gmon-static-pie-gprof.out
endif
endif


include ../Rules

# We cannot compile mcount.c with -pg because that would
# create recursive calls.  Just copy the normal static object.
# On systems where `profil' is not a system call, the same
# problem exists for the internal functions in profil.c.

noprof := mcount $(sysdep_noprof)
ifeq (,$(filter profil,$(unix-syscalls)))
noprof += profil sprofil
endif

$(noprof:%=$(objpfx)%.op): %.op: %.o
	rm -f $@
	ln $< $@

# GMON_OUTPUT_PREFIX only sets the output prefix.  The actual file
# name contains the PID as well.
$(objpfx)tst-gmon.out: clean-tst-gmon-data
clean-tst-gmon-data:
	rm -f $(objpfx)tst-gmon.data.*

$(objpfx)tst-mcount-overflow.o: clean-tst-mcount-overflow-data
clean-tst-mcount-overflow-data:
	rm -f $(objpfx)tst-mcount-overflow.data.*

$(objpfx)tst-mcount-overflow-check.out: tst-mcount-overflow-check.sh $(objpfx)tst-mcount-overflow.out
	$(SHELL) $< $(objpfx)tst-mcount-overflow > $@; \
	$(evaluate-test)

$(objpfx)tst-mcleanup.out: clean-tst-mcleanup-data
clean-tst-mcleanup-data:
	rm -f $(objpfx)tst-mcleanup.data.*

$(objpfx)tst-gmon-gprof.out: tst-gmon-gprof.sh $(objpfx)tst-gmon.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon $(objpfx)tst-gmon.data.* > $@; \
	$(evaluate-test)

$(objpfx)tst-gmon-static.out: clean-tst-gmon-static-data
clean-tst-gmon-static-data:
	rm -f $(objpfx)tst-gmon-static.data.*

$(objpfx)tst-gmon-static-gprof.out: tst-gmon-static-gprof.sh \
				    $(objpfx)tst-gmon-static.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon-static \
		$(objpfx)tst-gmon-static.data.* > $@; \
	$(evaluate-test)

$(objpfx)tst-gmon-pie.out: clean-tst-gmon-pie-data
clean-tst-gmon-pie-data:
	rm -f $(objpfx)tst-gmon-pie.data.*

$(objpfx)tst-gmon-pie-gprof.out: tst-gmon-gprof.sh $(objpfx)tst-gmon-pie.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon-pie $(objpfx)tst-gmon-pie.data.* > $@; \
	$(evaluate-test)

$(objpfx)tst-gmon-static-pie.out: clean-tst-gmon-static-pie-data
clean-tst-gmon-static-pie-data:
	rm -f $(objpfx)tst-gmon-static-pie.data.*

$(objpfx)tst-gmon-static-pie-gprof.out: tst-gmon-static-gprof.sh \
					$(objpfx)tst-gmon-static-pie.out
	$(SHELL) $< $(GPROF) $(objpfx)tst-gmon-static-pie \
		$(objpfx)tst-gmon-static-pie.data.* > $@; \
	$(evaluate-test)

=== glibc/localedata/unicode-gen/Makefile ===
# Copyright (C) 2015-2024 Free Software Foundation, Inc
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for generating and updating Unicode-extracted files.


# This Makefile is NOT used as part of the GNU libc build.  It needs
# to be run manually, within the source tree, at Unicode upgrades
# (change UNICODE_VERSION below), to update ../locales/i18n_ctype ctype
# information (part of the file is preserved, so don't wipe it all
# out), and ../charmaps/UTF-8.

# Use make all to generate the files used in the glibc build out of
# the original Unicode files; make check to verify that they are what
# we expect; make install to copy them to the location expected by the
# glibc build; and make clean to remove all generated files.

# We keep a local copy of the downloaded Unicode files, to avoid
# running afoul of the LGPL corresponding sources requirements, even
# though it's not clear that they are preferred over the generated
# files for making modifications.


UNICODE_VERSION = 15.1.0

PYTHON3 = python3
WGET = wget

DOWNLOADS = UnicodeData.txt DerivedCoreProperties.txt EastAsianWidth.txt HangulSyllableType.txt
LICENSE = unicode-license.txt
GENERATED = i18n_ctype tr_TR UTF-8 translit_combining translit_compat translit_circle translit_cjk_compat translit_font translit_fraction
REPORTS = i18n_ctype-report UTF-8-report

all: $(GENERATED)

check: check-i18n_ctype check-UTF-8

install:
	cp -p i18n_ctype ../locales/i18n_ctype
	cp -p tr_TR ../locales/tr_TR
	cp -p UTF-8 ../charmaps/UTF-8
	cp -p translit_combining ../locales/translit_combining
	cp -p translit_compat ../locales/translit_compat
	cp -p translit_circle ../locales/translit_circle
	cp -p translit_cjk_compat ../locales/translit_cjk_compat
	cp -p translit_font ../locales/translit_font
	cp -p translit_fraction ../locales/translit_fraction

clean: mostlyclean
	-rm -rf __pycache__
mostlyclean:
	-rm -f $(REPORTS) $(GENERATED)

.PHONY: all check clean mostlyclean install

i18n_ctype: UnicodeData.txt DerivedCoreProperties.txt
i18n_ctype: ../locales/i18n_ctype # Preserve non-ctype information.
i18n_ctype: gen_unicode_ctype.py
	$(PYTHON3) gen_unicode_ctype.py -u UnicodeData.txt \
	  -d DerivedCoreProperties.txt -i ../locales/i18n_ctype -o $@ \
	  --unicode_version $(UNICODE_VERSION)

i18n_ctype-report: i18n_ctype ../locales/i18n_ctype
i18n_ctype-report: ctype_compatibility.py ctype_compatibility_test_cases.py
	$(PYTHON3) ./ctype_compatibility.py -o ../locales/i18n_ctype \
	  -n i18n_ctype -a -m > $@

check-i18n_ctype: i18n_ctype-report
	@if grep '\(Missing\|Added\) [^0]\|^Number of errors[^=]* = [^0]' \
		i18n_ctype-report; \
	then echo manual verification required; false; else true; fi

tr_TR: UnicodeData.txt DerivedCoreProperties.txt
tr_TR: ../locales/tr_TR # Preserve non-ctype information.
tr_TR: gen_unicode_ctype.py
	$(PYTHON3) gen_unicode_ctype.py -u UnicodeData.txt \
	  -d DerivedCoreProperties.txt -i ../locales/tr_TR -o $@ \
	  --unicode_version $(UNICODE_VERSION) --turkish

UTF-8: UnicodeData.txt DerivedCoreProperties.txt EastAsianWidth.txt HangulSyllableType.txt
UTF-8: utf8_gen.py
	$(PYTHON3) utf8_gen.py -u UnicodeData.txt \
	-d DerivedCoreProperties.txt \
	-e EastAsianWidth.txt \
	-k HangulSyllableType.txt \
	--unicode_version $(UNICODE_VERSION)

UTF-8-report: UTF-8 ../charmaps/UTF-8
UTF-8-report: utf8_compatibility.py
	$(PYTHON3) ./utf8_compatibility.py -u UnicodeData.txt \
	-e EastAsianWidth.txt -o ../charmaps/UTF-8 \
	-n UTF-8 -a -m -c > $@

check-UTF-8: UTF-8-report
	@if grep '^Total.*: [^0]' UTF-8-report; \
	then echo manual verification required; false; else true; fi

translit_combining: UnicodeData.txt
translit_combining: gen_translit_combining.py
	$(PYTHON3) ./gen_translit_combining.py -u UnicodeData.txt \
	-o $@ --unicode_version $(UNICODE_VERSION)

translit_compat: UnicodeData.txt
translit_compat: gen_translit_compat.py
	$(PYTHON3) ./gen_translit_compat.py -u UnicodeData.txt \
	-o $@ --unicode_version $(UNICODE_VERSION)

translit_circle: UnicodeData.txt
translit_circle: gen_translit_circle.py
	$(PYTHON3) ./gen_translit_circle.py -u UnicodeData.txt \
	-o $@ --unicode_version $(UNICODE_VERSION)

translit_cjk_compat: UnicodeData.txt
translit_cjk_compat: gen_translit_cjk_compat.py
	$(PYTHON3) ./gen_translit_cjk_compat.py -u UnicodeData.txt \
	-o $@ --unicode_version $(UNICODE_VERSION)

translit_font: UnicodeData.txt
translit_font: gen_translit_font.py
	$(PYTHON3) ./gen_translit_font.py -u UnicodeData.txt \
	-o $@ --unicode_version $(UNICODE_VERSION)

translit_fraction: UnicodeData.txt
translit_fraction: gen_translit_fraction.py
	$(PYTHON3) ./gen_translit_fraction.py -u UnicodeData.txt \
	-o $@ --unicode_version $(UNICODE_VERSION)

.PHONY: downloads clean-downloads
downloads: $(DOWNLOADS) $(LICENSE)
clean-downloads:
	-rm -f $(DOWNLOADS) $(LICENSE)

$(DOWNLOADS):
	$(WGET) http://www.unicode.org/Public/$(UNICODE_VERSION)/ucd/$@

$(LICENSE):
	$(WGET) https://www.unicode.org/license.txt --output-document=$@

=== debian/changelog ===
liblol (0.1.6-1deepin1) unstable; urgency=medium

  * Build with GCC 12.

 -- Mingcong Bai <baimingcong@uniontech.com>  Fri, 17 Jan 2025 10:49:59 +0800

liblol (0.1.6-1) unstable; urgency=medium

  * Release 0.1.6-1

 -- Miao Wang <shankerwangmiao@gmail.com>  Mon, 16 Sep 2024 22:18:00 +0800

liblol (0.1.6~pre2-1) unstable; urgency=medium

  * Release 0.1.6~pre2-1
  * fix implementation of lxstat64

 -- Miao Wang <shankerwangmiao@gmail.com>  Sat, 31 Aug 2024 23:36:00 +0800

=== debian/control ===
Source: liblol
Section: otherosfs
Priority: optional
Maintainer: Miao Wang <shankerwangmiao@gmail.com>
Build-Depends: debhelper-compat (= 13),
               libstdc++6,
               libltdl-dev,
               quilt,
               bison,
               gawk,
               python3,
Standards-Version: 4.6.2
Homepage: https://github.com/AOSC-Dev/liblol

Package: liblol
Architecture: loong64
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libstdc++6,
         libc6 (>= 2.36),
         libc6 (<< ${glibcVer}.1~),
Breaks: libcrypt1 (>= 1:${libxcryptVer}.1~)
Conflicts: glibc,
Recommends: liblol-dkms,
Description: Compatibility layer for old world applications
  This package contains a Compatibility layer for old world
  applications on new world loongarch64 platform.

=== debian/rules ===
#! /usr/bin/make -f


include /usr/share/dpkg/pkg-info.mk

glibc-ver := 2.40
patchelf-ver := 0.18.0
libxcrypt-ver := 4.4.36

SUBSTVARS += -VglibcVer="$(glibc-ver)" -VlibxcryptVer="$(libxcrypt-ver)"

glibc-orig = ../liblol_$(DEB_VERSION_UPSTREAM).orig-glibc.tar.xz
patchelf-orig = ../liblol_$(DEB_VERSION_UPSTREAM).orig-patchelf.tar.gz
libxcrypt-orig = ../liblol_$(DEB_VERSION_UPSTREAM).orig-libxcrypt.tar.xz
main-orig = ../liblol_$(DEB_VERSION_UPSTREAM).orig.tar.xz

DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
lol_target_gnu_type := loongarch64-debian-linux-gnuow

build_cflags := -pipe $(shell dpkg-buildflags --get CFLAGS_FOR_BUILD) $(shell dpkg-buildflags --get CPPFLAGS_FOR_BUILD)
build_cxxflags := -pipe $(shell dpkg-buildflags --get CXXFLAGS_FOR_BUILD) $(shell dpkg-buildflags --get CPPFLAGS_FOR_BUILD)
build_ldflags := $(shell dpkg-buildflags --get LDFLAGS_FOR_BUILD)
host_cflags := -pipe $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
host_ldflags := $(shell dpkg-buildflags --get LDFLAGS)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

BASE_CC = gcc
DEB_GCC_VERSION = -12

CC = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib64
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

get-orig-source: $(glibc-orig) $(patchelf-orig) $(libxcrypt-orig) $(main-orig)
	:

$(glibc-orig):
	curl -sSfL -o $@ https://ftp.debian.org/debian/pool/main/g/glibc/glibc_$(glibc-ver).orig.tar.xz
$(patchelf-orig):
	curl -sSfL -o $@ https://ftp.debian.org/debian/pool/main/p/patchelf/patchelf_$(patchelf-ver).orig.tar.gz
$(libxcrypt-orig):
	curl -sSfL -o $@ https://ftp.debian.org/debian/pool/main/libx/libxcrypt/libxcrypt_$(libxcrypt-ver).orig.tar.xz
$(main-orig):
	tar -cJf $@ -T /dev/null
%:
	dh $@ --without autoreconf

config-libxcrypt config-libxcrypt-normal: autoreconf
	mkdir -p debian/build-dir/$(subst config-,,$@)
	cd debian/build-dir/$(subst config-,,$@) && \
	$(CURDIR)/libxcrypt/configure \
	  --build=$(DEB_BUILD_GNU_TYPE) \
	  --host=$(lol_target_gnu_type) \
	  --prefix=/usr \
	  --disable-werror \
	  --disable-xcrypt-compat-files \
	  --enable-obsolete-api=glibc \
	  --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CFLAGS='$(host_cflags)' \
	  LDFLAGS='$(host_ldflags)'

patchelf_build_dir := debian/build-dir/patchelf

config-patchelf: patch-src.patchelf autoreconf
	mkdir -p $(patchelf_build_dir)
	cd $(patchelf_build_dir) && \
	$(CURDIR)/patchelf/configure \
	  --build=$(DEB_BUILD_GNU_TYPE) \
	  --host=$(DEB_BUILD_GNU_TYPE) \
	  CFLAGS='$(build_cflags)' \
	  CXXFLAGS='$(build_cxxflags)' \
	  LDFLAGS='$(build_ldflags)'

autoreconf: patch-src
	dh_autoreconf autoreconf -- -f -i patchelf/ libxcrypt/

glibc_build_dir := debian/build-dir/glibc
config-glibc: patch-src.glibc
	mkdir -p $(glibc_build_dir)
	rm -rf $(glibc_build_dir)/configparms
	echo "BUILD_CC = $(BUILD_CC)"             >> $(glibc_build_dir)/configparms
	echo "CFLAGS = $(host_cflags)"            >> $(glibc_build_dir)/configparms
	echo "ASFLAGS = $(host_cflags)"           >> $(glibc_build_dir)/configparms
	echo "BUILD_CFLAGS = $(build_cflags)"     >> $(glibc_build_dir)/configparms
	echo "LDFLAGS = "                         >> $(glibc_build_dir)/configparms
	echo "BASH := /bin/bash"                  >> $(glibc_build_dir)/configparms
	echo "KSH := /bin/bash"                   >> $(glibc_build_dir)/configparms
	echo "SHELL := /bin/bash"                 >> $(glibc_build_dir)/configparms
	echo "LIBGD = no"                         >> $(glibc_build_dir)/configparms
	echo "bindir = $(bindir)"                 >> $(glibc_build_dir)/configparms
	echo "datadir = $(datadir)"               >> $(glibc_build_dir)/configparms
	echo "complocaledir = $(complocaledir)"   >> $(glibc_build_dir)/configparms
	echo "sysconfdir = $(sysconfdir)/liblol"  >> $(glibc_build_dir)/configparms
	echo "localtime-file = $(sysconfdir)/localtime" >> $(glibc_build_dir)/configparms
	echo "libexecdir = $(libexecdir)"         >> $(glibc_build_dir)/configparms
	echo "rootsbindir = $(rootsbindir)"       >> $(glibc_build_dir)/configparms
	echo "includedir = $(includedir)"         >> $(glibc_build_dir)/configparms
	echo "docdir = $(docdir)"                 >> $(glibc_build_dir)/configparms
	echo "mandir = $(mandir)"                 >> $(glibc_build_dir)/configparms
	echo "sbindir = $(sbindir)"               >> $(glibc_build_dir)/configparms
	echo "vardbdir = $(vardbdir)"             >> $(glibc_build_dir)/configparms
	echo "libdir = $(libdir)"                 >> $(glibc_build_dir)/configparms
	echo "slibdir = $(slibdir)"               >> $(glibc_build_dir)/configparms
	echo "rtlddir = $(rtlddir)"               >> $(glibc_build_dir)/configparms
	echo "user-defined-trusted-dirs-pre = /usr/local/lib/$(lol_target_gnu_type)/preload:/usr/lib/$(lol_target_gnu_type)/preload" >> $(glibc_build_dir)/configparms
	echo "user-defined-trusted-dirs = /usr/local/lib/$(lol_target_gnu_type):/usr/lib/$(lol_target_gnu_type)" >> $(glibc_build_dir)/configparms
	cd $(glibc_build_dir) && \
		CC=$(CC) \
		AUTOCONF=false \
		MAKEINFO=: \
		$(CURDIR)/glibc/configure \
		--host=$(lol_target_gnu_type) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr \
		--without-selinux \
		--enable-bind-now \
		--enable-fortify-source \
		--enable-stackguard-randomization \
		--enable-stack-protector=strong \
		--with-pkgversion="LibLoL $(DEB_VERSION)" \
		--with-bugurl="https://github.com/AOSC-Dev/liblol/issues" \
		--disable-nscd \
		--disable-werror \
		--enable-multi-arch \
		--enable-obsolete-rpc

glibc_real_libs = \
		libc.so.6 \
		nptl/libpthread.so.0 \
		elf/ld.so.1 \
		math/libm.so.6 \
		resolv/libresolv.so.2 \
		malloc/libc_malloc_debug.so.0 \
		nptl_db/libthread_db.so.1 \
		locale/libBrokenLocale.so.1
glibc_no_promote_libs = \
		resolv/libanl.so.1 \
        dlfcn/libdl.so.2 \
        rt/librt.so.1 \
        login/libutil.so.1 \
        nis/libnsl.so.1
glibc_merged_libs = \
	$(filter-out, nis/libnsl.so.1, $(glibc_no_promote_libs)) \
	nptl/libpthread.so.0

glibc_libs = $(glibc_real_libs) $(glibc_no_promote_libs)

glibc_libs_targets = $(addprefix $(glibc_build_dir)/,$(glibc_libs))
glibc_libs_targets_after = $(addprefix $(glibc_build_dir)/,$(filter-out libc.so.6 elf/ld.so.1,$(glibc_libs)))

glibc_libs_install_targets = $(addprefix install-glibc-,$(subst /,-,$(glibc_libs)))

patchelf_bin := $(patchelf_build_dir)/src/patchelf

build-patchelf: $(patchelf_bin)

build-glibc: $(glibc_libs_targets)
	:

$(glibc_libs_targets_after): $(glibc_build_dir)/libc.so.6 $(glibc_build_dir)/linkobj/libc.so $(glibc_build_dir)/elf/ld.so.1 $(glibc_build_dir)/stamp_elfpatched
$(glibc_libs_targets): $(glibc_build_dir)/config.status
$(addprefix $(glibc_build_dir)/,$(glibc_real_libs)): $(patchelf_bin)

define patchelf_pthread
$(patchelf_bin) \
	--page-size "$$(( 16 * 1024 ))" \
	--remap-symvers "GLIBC_2.27=GLIBC_2.0,GLIBC_2.2,GLIBC_2.2.1,GLIBC_2.2.2,GLIBC_2.2.3,GLIBC_2.2.4,GLIBC_2.2.6,GLIBC_2.3,GLIBC_2.3.2,GLIBC_2.3.3,GLIBC_2.3.4,GLIBC_2.4,GLIBC_2.5,GLIBC_2.6,GLIBC_2.7,GLIBC_2.8,GLIBC_2.9,GLIBC_2.10,GLIBC_2.11,GLIBC_2.12,GLIBC_2.13,GLIBC_2.14,GLIBC_2.15,GLIBC_2.16,GLIBC_2.17,GLIBC_2.18,GLIBC_2.19,GLIBC_2.20,GLIBC_2.21,GLIBC_2.22,GLIBC_2.23,GLIBC_2.24,GLIBC_2.25,GLIBC_2.26" \
	--also-remap-verneed
endef

define patchelf_normal
$(patchelf_bin) \
	--page-size "$$(( 16 * 1024 ))" \
	--remap-symvers "GLIBC_2.36=GLIBC_2.27,GLIBC_2.28" \
	--also-remap-verneed
endef
